Coalesce rsync options, plus misc cleanups
authorFSF BOFH <sysadmin-nonrt@fsf.org>
Tue, 26 Jul 2011 01:30:36 +0000 (21:30 -0400)
committerFSF BOFH <sysadmin-nonrt@fsf.org>
Tue, 26 Jul 2011 01:30:36 +0000 (21:30 -0400)
wizbackup

index 034651a997fd3747d17f4c4c257ed3bda82796df..ad7a549ce2c099fadc0998e3f6e43fc489d163dd 100755 (executable)
--- a/wizbackup
+++ b/wizbackup
@@ -32,21 +32,21 @@ DEST=$1; shift
 
 # NOTE: --timeout needs to be large enough: if a large dir tree don't change a lot of time can pass without I/O
 # NOTE: --inplace will clobber linked files in older snapshots. DON'T USE IT!
 
 # NOTE: --timeout needs to be large enough: if a large dir tree don't change a lot of time can pass without I/O
 # NOTE: --inplace will clobber linked files in older snapshots. DON'T USE IT!
-RSYNC_OPTIONS="-HAXa --stats --timeout 1800 --numeric-ids --delete --delete-excluded --ignore-errors $@"
-# NUMBER OF SAVED ARCHIVES
-N_SNAPSHOT=45
-RESULT=500
+RSYNC_OPTS="-HAXa --stats --timeout 1800 --numeric-ids --delete --delete-excluded --ignore-errors $@"
+
+# Number of saved snapshots
+SNAPSHOTS=45
 
 
+RESULT=500
 DATE=`date +"%Y%m%d"`
 DEST="`echo $DEST | sed -e 's/\/$//'`"
 
 
 # Use "backup" ssh key with ssh protocol, or password file for rsync protocol
 if [ "${SRC%:*}" == "rsync" ]; then
 DATE=`date +"%Y%m%d"`
 DEST="`echo $DEST | sed -e 's/\/$//'`"
 
 
 # Use "backup" ssh key with ssh protocol, or password file for rsync protocol
 if [ "${SRC%:*}" == "rsync" ]; then
-       RSYNC_PWD="--password-file=/etc/wizbackup.pwd --contimeout 10"
+       RSYNC_OPTS="$RSYNC_OPTS --password-file=/etc/wizbackup/rsync_password --contimeout 10"
 else
 else
-       export RSYNC_RSH="ssh -i /root/.ssh/id_backup -c arcfour -x -o VerifyHostKeyDNS=yes"
-       RSYNC_PWD=""
+       export RSYNC_RSH="ssh -i /etc/wizbackup/ssh_id -c arcfour -x -o VerifyHostKeyDNS=yes -o StrictHostKeyChecking=no"
 fi
 
 # Error tolerant grep
 fi
 
 # Error tolerant grep
@@ -59,8 +59,8 @@ tgrep()
 do_backup()
 {
        set -o pipefail
 do_backup()
 {
        set -o pipefail
-       echo "$(date): Starting rsync: rsync $RSYNC_PWD $RSYNC_OPTIONS $SRC $DEST/$DATE/"
-       rsync $RSYNC_PWD $RSYNC_OPTIONS "$SRC" "$DEST/tmp/" 2>&1 | tgrep -v -E 'vanished|some files'
+       echo "$(date): rsync $RSYNC_OPTS $SRC $DEST/tmp/"
+       rsync $RSYNC_OPTS "$SRC" "$DEST/tmp/" 2>&1 | tgrep -v -E 'vanished|some files'
        RESULT=$?
        case "$RESULT" in
        0|24)
        RESULT=$?
        case "$RESULT" in
        0|24)
@@ -98,7 +98,7 @@ do_init()
 
 do_prune()
 {
 
 do_prune()
 {
-       local old="`ls | grep -v tmp | head -n -$N_SNAPSHOT`"
+       local old="`ls | grep -v tmp | head -n -$SNAPSHOTS`"
        if [ ! -z "$old" ]; then
                echo "$(date): Removing oldest snapshot(s): $old..."
                rm -rf "$old" || exit 669
        if [ ! -z "$old" ]; then
                echo "$(date): Removing oldest snapshot(s): $old..."
                rm -rf "$old" || exit 669
@@ -108,10 +108,10 @@ do_prune()
 do_link()
 {
        local newest=`ls | grep  -v tmp | tail -n 1`
 do_link()
 {
        local newest=`ls | grep  -v tmp | tail -n 1`
-       if [ -z "$newest" ]; then
+       if [ -d "$DEST/tmp" ]; then
+               echo "$(date): Continuing with pre-existing snapshot $DEST/tmp"
+       elif [ -z "$newest" ]; then
                echo "$(date): No previous snapshot found, performing a full backup!"
                echo "$(date): No previous snapshot found, performing a full backup!"
-       elif [ -d "$DEST/tmp" ]; then
-               echo "$(date): Continuing with preexisting snapshot $DEST/tmp"
        else
                echo "$(date): Linking snapshot $DEST/$newest to $DEST/tmp"
                # TODO: Creating the hardlinks takes a lot of time.
        else
                echo "$(date): Linking snapshot $DEST/$newest to $DEST/tmp"
                # TODO: Creating the hardlinks takes a lot of time.
@@ -125,7 +125,7 @@ do_test()
        # Avoid clobbering the latest snapshot if the remote host does
        # not allow us to connect
        # --contimeout: sometimes hangs on connection...
        # Avoid clobbering the latest snapshot if the remote host does
        # not allow us to connect
        # --contimeout: sometimes hangs on connection...
-       rsync $RSYNC_PWD $RSYNC_OPTIONS --dry-run --no-recursive "$SRC" >/dev/null
+       rsync $RSYNC_OPTS --dry-run --no-recursive "$SRC" >/dev/null
        RESULT=$?
        if [ $RESULT -ne 0 ]; then
                echo "$(date): rsync test failed: $RESULT.  Aborting."
        RESULT=$?
        if [ $RESULT -ne 0 ]; then
                echo "$(date): rsync test failed: $RESULT.  Aborting."